#include	"myW25Qxx.h"
#include  "STC32G_GPIO.h"
#include  "STC32G_NVIC.h"
#include  "STC32G_SPI.h"
#include  "STC32G_Clock.h"
#include  "STC32G_Switch.h"


//*--------------------------[]-------------------------------------
u8  B_FlashOK;                                //Flash״̬
u8  FLASH_ID, FLASH_ID1, FLASH_ID2;


#if defined(W25Qxx_SPI_DMA)
u8 xdata DmaTxBuffer[EE_PageSize]; //_at_ DMA_TX_ADDR;
u8 xdata DmaRxBuffer[EE_PageSize]; //_at_ DMA_RX_ADDR;

BOOL SPI_DmaFlag;
#endif
//----------------------------[]--------------------------------*/


//========================================================================
// 		: W25Qxx_init()
// 	:  
// ֵ		: 
// ϸ˵	: ʼW25Qxx
// 
// 汾			: V
//========================================================================
void W25Qxx_init()
{
	SPI_InitTypeDef		SPI_InitStructure;

	SPI_InitStructure.SPI_Enable    = ENABLE;				//SPI    ENABLE, DISABLE
	SPI_InitStructure.SPI_SSIG      = DISABLE;				//Ƭѡλ     ENABLE(SSȷӻ), DISABLE(SSŹ)
	SPI_InitStructure.SPI_FirstBit  = SPI_MSB;				//λ   SPI_MSB, SPI_LSB
	SPI_InitStructure.SPI_Mode      = SPI_Mode_Master;		//ѡ   SPI_Mode_Master, SPI_Mode_Slave
	SPI_InitStructure.SPI_CPOL      = SPI_CPOL_High;		//ʱλ   SPI_CPOL_High,   SPI_CPOL_Low
	SPI_InitStructure.SPI_CPHA      = SPI_CPHA_2Edge;		//ݱ   SPI_CPHA_1Edge,  SPI_CPHA_2Edge
	SPI_InitStructure.SPI_Speed     = SPI_Speed_4;			//SPIٶ    SPI_Speed_4, SPI_Speed_8, SPI_Speed_16, SPI_Speed_2
	SPI_Init(&SPI_InitStructure);
	NVIC_SPI_Init(DISABLE,Priority_0);		//жʹ, ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3
	SPI_ClearFlag();   // SPIFWCOL ־

	HSPllClkConfig(MCLKSEL_HIRC,PLL_96M,4);    //ϵͳʱѡ,PLLʱѡ,ʱӷƵϵ
	HSSPI_Enable();
	
	SPI_SW(W25Qxx_IO_SW);
	W25Qxx_IO_config();
	W25Qxx_SCK_LOW();
	W25Qxx_SI_HIGH();
	W25Qxx_DISABLE();
	
	
}

//========================================================================
// 		: W25Qxx_CheckBusy()
// 	:  
// ֵ		: Status
// ϸ˵	:
// 
// 汾			: V
//========================================================================
u8 W25Qxx_CheckBusy()
{
    u8  Status;
    W25Qxx_ENABLE();
    SPI_WriteByte(SFC_RDSR);        		//Ͷȡ״̬
    Status = SPI_ReadByte();           //ȡ״̬
    W25Qxx_DISABLE();
    return (Status);                   //״ֵ̬Bit0Ϊæ־
}


//========================================================================
// 		: 
// 	:  
// ֵ		:
// ϸ˵	:
// 
// 汾			: V
//========================================================================
void FlashCheckID(void)
{
    W25Qxx_ENABLE();
    SPI_WriteByte(SFC_RDID);        //ͶȡID
    SPI_WriteByte(0x00);            //ն3ֽ
    SPI_WriteByte(0x00);
    SPI_WriteByte(0x00);
    FLASH_ID1 = SPI_ReadByte();     //ȡID1
    FLASH_ID  = SPI_ReadByte();     //ȡ豸ID
    FLASH_ID2 = SPI_ReadByte();     //ȡID2
    W25Qxx_DISABLE();

    if((FLASH_ID1 == 0x9d) && (FLASH_ID2 == 0x7f))  B_FlashOK = 1;  //ǷΪPM25LVxxϵеFlash
    else if(FLASH_ID == 0x12)  B_FlashOK = 2;                       //ǷΪW25X4xϵеFlash
    else if(FLASH_ID == 0x13)  B_FlashOK = 3;                       //ǷΪW25X8xϵеFlash
		else if(FLASH_ID == 0x15)  B_FlashOK = 4;												//ǷΪW25Q32ϵеFlash
		else if(FLASH_ID == 0x16)  B_FlashOK = 5;												//ǷΪW25Q64ϵеFlash
    else B_FlashOK = 0;
}


//========================================================================
// 		: W25Qxx_WriteEnable()
// 	:  
// ֵ		: 
// ϸ˵	: дʹ
// 
// 汾			: V
//========================================================================
void W25Qxx_WriteEnable()
{
    while(W25Qxx_CheckBusy() > 0);    //Flashæ
    W25Qxx_ENABLE();
    SPI_WriteByte(SFC_WREN);        //дʹ
    W25Qxx_DISABLE();
}


//========================================================================
// 		: W25Qxx_ChipErase()
// 	: 
// ֵ		: 
// ϸ˵	: ַڵоƬ
// 
// 汾			: V
//========================================================================
void W25Qxx_ChipErase()
{
    if(B_FlashOK)
    {
        W25Qxx_WriteEnable();             //ʹFlashд
        W25Qxx_ENABLE();
        SPI_WriteByte(SFC_CHIPER);      //Ƭ
        W25Qxx_DISABLE();
    }
}

//========================================================================
// 		: W25Qxx_SectorErase(u32 addr)
// 	: addr: ַ 
// ֵ		: 
// ϸ˵	: ַڵ
// 
// 汾			: V
//========================================================================
void W25Qxx_SectorErase(u32 addr)
{
    if(B_FlashOK)
    {
        W25Qxx_WriteEnable();             //ʹFlashд
        W25Qxx_ENABLE();
        if(B_FlashOK == 1)
        {
            SPI_WriteByte(SFC_SECTORER1);    //
        }
        else
        {
            SPI_WriteByte(SFC_SECTORER2);    //
        }
        SPI_WriteByte(((u8 *)&addr)[1]);           //ʼַ
        SPI_WriteByte(((u8 *)&addr)[2]);
        SPI_WriteByte(((u8 *)&addr)[3]);
        W25Qxx_DISABLE();
    }
}

//========================================================================
// 		: W25Qxx_Read_nBytes(u32 addr, u8 *buffer, u16 DataSize)
// 	: addr: ʼַ 
//						buffer: Żַ				//ʹDMAʱ
//						DataSizeݴС					
// ֵ		: 
// ϸ˵	: 
// 
// 汾			: V
//========================================================================
void W25Qxx_Read_Nbytes(u32 addr, u8 *buffer, u16 DataSize)
{
    if(DataSize == 0)   return;
    if(!B_FlashOK)  		return;
		#if defined(W25Qxx_SPI_DMA)
		while(SPI_DmaFlag);        						
		#endif
    while(W25Qxx_CheckBusy() > 0);        //Flashæ

    W25Qxx_ENABLE();                       //enable device
    SPI_WriteByte(SFC_READ);            //read command

    SPI_WriteByte(((u8 *)&addr)[1]);    //ʼַ
    SPI_WriteByte(((u8 *)&addr)[2]);
    SPI_WriteByte(((u8 *)&addr)[3]);

		#if defined(W25Qxx_SPI_DMA)
    SPI_DmaFlag = 1;
//    DMA_SPI_AMT = DataSize-1;	//ôֽn+1
		SET_DMA_SPI_AMT(DataSize-1);
    DMA_SPI_TRIG_M();     		//ʼSPI_DMAģʽ										
		#else
    do{
        *buffer = SPI_ReadByte();       //receive byte and store at buffer
        buffer++;
    }while(--DataSize);                     //read until no_bytes is reached
    W25Qxx_DISABLE();                      //disable device
		#endif
}
//========================================================================
// 		: SPI_Read_Compare(u32 addr, u8 *buffer, u16 DataSize)
// 	: addr: ʼַ							//ʹDMAʱ 
//						buffer: Żַ				//ʹDMAʱ
//						DataSizeݴС					
// ֵ		: j
// ϸ˵	: 
// 
// 汾			: V
//========================================================================
u8 W25Qxx_Read_Compare(u32 addr, u8 *buffer, u16 DataSize)
{
    u8  j=0;
    if(DataSize == 0)   return 2;
    if(!B_FlashOK)  		return 2;
		
		#if defined(W25Qxx_SPI_DMA)
		while(SPI_DmaFlag); 
		do
    {
        if(DmaRxBuffer[j] != DmaTxBuffer[j]) return 1;      //receive byte and store at buffer
        j++;
    }while(--DataSize);        										 //read until no_bytes is
		#else
		while(W25Qxx_CheckBusy() > 0);            //Flashæ
    W25Qxx_ENABLE();                           //enable device
    SPI_WriteByte(SFC_READ);                //read command
    SPI_WriteByte(((u8 *)&addr)[1]);        //ʼַ
    SPI_WriteByte(((u8 *)&addr)[2]);
    SPI_WriteByte(((u8 *)&addr)[3]);
    do
    {
        if(*buffer != SPI_ReadByte()) return 1;     //receive byte and store at buffer
        buffer++;
    }while(--DataSize);         //read until no_bytes is reached
    W25Qxx_DISABLE();          //disable device
		#endif
		
    return 0;
}

//========================================================================
// 		: 25Qxx_Write_Nbytes(u32 addr, u8 *buffer, u8 DataSize)
// 	: addr: ʼַ 
//						buffer: Żַ			//ʹDMAʱ
//						DataSizeݴС					
// ֵ		: 
// ϸ˵	: W25Qxx
// 
// 汾			: V
//========================================================================
void W25Qxx_Write_Nbytes(u32 addr, u8 *buffer, u8 DataSize)
{
	if(DataSize == 0)   return;
	if(!B_FlashOK)  return;
	
	#if defined(W25Qxx_SPI_DMA)
	while(SPI_DmaFlag); 
	#endif
	
	while(W25Qxx_CheckBusy() > 0);        //Flashæ
	W25Qxx_WriteEnable();                 //ʹFlashд
	W25Qxx_ENABLE();                       // enable device
	SPI_WriteByte(SFC_PAGEPROG);        // ҳ
	SPI_WriteByte(((u8 *)&addr)[1]);    //ʼַ
	SPI_WriteByte(((u8 *)&addr)[2]);
	SPI_WriteByte(((u8 *)&addr)[3]);
	
	#if defined(W25Qxx_SPI_DMA)
  SPI_DmaFlag = 1;
//  DMA_SPI_AMT = DataSize-1;						//ôֽn+1
	SET_DMA_SPI_AMT(DataSize-1);
  DMA_SPI_TRIG_M();    								 //ʼSPI_DMAģ
	
	#else 
	do{
			SPI_WriteByte(*buffer++);       //ҳд
			addr++;
			if ((addr & 0xff) == 0) break;
    }while(--DataSize);
	W25Qxx_DISABLE();                      
	#endif
}

