
#ifndef	__MYW25Qxx_H
#define	__MYW25Qxx_H

#include	"config.h"

#define W25Qxx_SPI_DMA
#if defined(W25Qxx_SPI_DMA)
#include	"STC32G_DMA.h"
#endif	//#if defined(W25Qxx_SPI_DMA)

#define EE_BUF_LENGTH       	255      //

#define EE_PageSize						256								//ҳС		
#define	EE_SectorSize					PageSize*16				//С
#define	EE_BlockSize					SectorSize*16			//

//#define	Storage_4M
//#define	storage_8M

//#if defined(Storage_4M)
//#define	Chip_Data_SAddr			0x002000
//#define	Chip_DataINFO_SAddr	0x000100
//#endif

#define Chip_MAX_ADDR 0xFFFFFF

//*--------------------------[ָ]-------------------------------------
#define SFC_WREN        0x06        //Flash
#define SFC_WRDI        0x04
#define SFC_RDSR        0x05
#define SFC_WRSR        0x01
#define SFC_READ        0x03
#define SFC_FASTREAD    0x0B
#define SFC_RDID        0xAB
#define SFC_PAGEPROG    0x02
#define SFC_RDCR        0xA1
#define SFC_WRCR        0xF1
#define SFC_SECTORER1   0xD7        //PM25LV040 ָ
#define SFC_SECTORER2   0x20        //W25Xxx ָ
#define SFC_BLOCKER     0xD8
#define SFC_CHIPER      0xC7
//------------------------[ָ]--------------------------------*/

//*--------------------------[Ŷ]-------------------------------------
#define W25Qxx_CS		P22								//CS				W25Qxx -> PIN1
#define W25Qxx_SO		P24								//MISO			W25Qxx -> PIN2
#define W25Qxx_SI		P23								//MOSI			W25Qxx -> PIN5
#define	W25Qxx_SCK	P25								//CLK				W25Qxx -> PIN6

#define W25Qxx_IO_SW				SPI_P22_P23_P24_P25

#define W25Qxx_IO_config()	P2_MODE_IO_PU(GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5);	\		
														P2_SPEED_HIGH(GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5)			//Ϊ

//#define W25Qxx_IO_config()	P2_MODE_OUT_OD(GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5);\																								
//														P2_SPEED_HIGH(GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5)			//Ϊ		
														
#define W25Qxx_ENABLE()			W25Qxx_CS  = LOW     
#define W25Qxx_DISABLE()		W25Qxx_CS  = HIGH  

#define W25Qxx_SI_HIGH()		W25Qxx_SI = HIGH
#define W25Qxx_SI_LOW()			W25Qxx_SI = LOW

#define W25Qxx_SCK_HIGH()		W25Qxx_SCK = HIGH
#define W25Qxx_SCK_LOW()		W25Qxx_SCK = LOW
//----------------------------[Ŷ]--------------------------------*/

//*--------------------------[]-------------------------------------
extern u8  B_FlashOK;                                //Flash״̬
extern u8  FLASH_ID, FLASH_ID1, FLASH_ID2;
//extern u16 Data_Page_SUM;	

#if defined(W25Qxx_SPI_DMA)
extern u8 xdata DmaTxBuffer[]; 
extern u8 xdata DmaRxBuffer[]; 
extern BOOL SPI_DmaFlag;
#endif
//----------------------------[]--------------------------------*/

//*--------------------------[]-------------------------------------
void W25Qxx_init();
void FlashCheckID();
u8 W25Qxx_CheckBusy();
void W25Qxx_WriteEnable();
void W25Qxx_SectorErase(u32 addr);
void W25Qxx_ChipErase();
void W25Qxx_Read_Nbytes(u32 addr, u8 *buffer, u16 DataSize);
u8 W25Qxx_Read_Compare(u32 addr, u8 *buffer, u16 DataSize);
void W25Qxx_Write_Nbytes(u32 addr, u8 *buffer, u8 DataSize);
//----------------------------[]--------------------------------*/

#endif

